#include <vector>
#include <map>
#include <set>
#include "algobot.h"

using namespace std;
set<int> pasarASet(vector<int> s){
    set<int> aux;
    for(int i=0; i< s.size(); i++ ){
        aux.insert(s[i]);
    }
    return aux;
}
// Ejercicio 1
vector<int> quitar_repetidos(vector<int> s) {
	set<int> aux;
	vector<int> res;
	for(int i=0; i< s.size(); i++ ){
			aux.insert(s[i]);
	} 

	for(int n:aux){
	    res.push_back(n);
	}
	
    return res;
}

// Ejercicio 2
vector<int> quitar_repetidos_v2(vector<int> s) {
	set<int> aux={};
	vector<int> res={};
	for(int i=0; i< s.size(); i++ ){
			aux.insert(s[i]);
	}
	for(int n:aux){
	    res.push_back(n);
	}
    return res;
}

// Ejercicio 3
bool mismos_elementos(vector<int> a, vector<int> b) {
	bool res=true;
    set<int> auxB = pasarASet(b);
	for(int i=0; i<a.size() && res; i++){
	    if(!auxB.count(a[i])){
                res=false;
	    }
	}
    set<int> auxA = pasarASet(a);
    for(int i=0; i<b.size() && res; i++){
        if(!auxA.count(b[i])){
            res=false;
        }
    }
    return res;
}

// Ejercicio 4
bool mismos_elementos_v2(vector<int> a, vector<int> b) {
    bool res=true;
    set<int> auxB = pasarASet(b);
    for(int i=0; i<a.size() && res; i++){
        if(!auxB.count(a[i])){
            res=false;
        }
    }
    set<int> auxA = pasarASet(a);
    for(int i=0; i<b.size() && res; i++){
        if(!auxA.count(b[i])){
            res=false;
        }
    }
    return res;
}

// Ejercicio 5
map<int, int> contar_apariciones(vector<int> s) {
	map<int,int > res;
	for(int n: s){
		if(res.count(n)==1){
			res.at(n)=res[n]+1;
		}else{
			res.insert(pair<int,int>(n,1));
		}
	}
    return res;
}

// Ejercicio 6
vector<int> filtrar_repetidos(vector<int> s) {
	map<int, int > numRepetidos = contar_apariciones(s);
	vector<int> res;
	for(pair<int, int> n : numRepetidos){
		if(numRepetidos[n.first]==1){
			res.push_back(n.first);
		}
	}
    return res;
}

// Ejercicio 7
set<int> interseccion(set<int> a, set<int> b) {
	set<int> res;
	for(int n:a){
		if(b.count(n)){
			res.insert(n);
		}
	}
    return res;
}

// Ejercicio 8
map<int, set<int>> agrupar_por_unidades(vector<int> s) {
	map<int, set<int>> res;
	for(int n:s){
		if(res.count(n%10)==1){
            set<int> aux = res[n%10];
            aux.insert(n);
			res.at(n%10)=aux;
		}else{
			set<int> conj= {n};
			res.insert(pair<int, set<int>>(n%10,conj));
		}
	}
    return res;
}

// Ejercicio 9
vector<char> traducir(vector<pair<char, char>> tr, vector<char> str) {
	vector<char> res;
	map<char,char> traducciones;
	for(pair<char,char> n:tr){
		traducciones.insert(pair<char,char>(n.first, n.second));//probar poner solo n
	}
	for(char n:str){
	    if(traducciones.count(n)==1){
            res.push_back(traducciones[n]);
	    }else {
	        res.push_back(n);
	    }

	}
    return res;
}

// Ejercicio 10
bool integrantes_repetidos(vector<Mail> s) {
    bool res = true;
    for (int i = 0; i < s.size()-1; ++i) {
        if(s[i].asunto()!=s[i+1].asunto()){
            return true;
        }
    }
    return res;
}

// Ejercicio 11
map<set<LU>, Mail> entregas_finales(vector<Mail> s) {
  return map<set<LU>, Mail>();
}
