#include <utility>

using namespace std;

// Ejercicio 15

// Juego

using Pos = pair<int, int>;

char ARRIBA = '^';
char ABAJO = 'v'; 
char DERECHA = '<';
char IZQUIERDA = '>';

class Juego {
  public:
    Juego(uint casilleros, Pos pos_inicial);
    Pos posicion_jugador();
    uint turno_actual();
    void mover_jugador(char dir);
    void ingerir_pocion(uint movimientos, uint turnos);
  private:
    uint casilleros_;
    Pos posicion_;
    uint turnos_;
    uint pasos_aux_;
    uint pasos_con_pocion_; //guarda la cantidad de pasos que puedo hacer sin sumar turnos
    uint turnos_con_pocion_;//cantidad de turnos que dura la posicion
};


Juego::Juego(uint casilleros, Pos pos_inicial):casilleros_(casilleros), posicion_(pos_inicial), turnos_(0), pasos_aux_(0), turnos_con_pocion_(0), pasos_con_pocion_(0)
{}
Pos Juego::posicion_jugador() {
    return posicion_;
}
uint Juego::turno_actual() {
    return turnos_;
}
void Juego::mover_jugador(char dir){
    if(dir==ARRIBA){
        if (posicion_.first-1>=0){
            posicion_.first-=1;
            pasos_aux_++;
            if(turnos_con_pocion_!=0){
                if (pasos_aux_==pasos_con_pocion_) {
                    turnos_++;
                    turnos_con_pocion_--;
                    pasos_aux_=0;
                }
            }else{
                turnos_++;
            }

        }
    }else if(dir==ABAJO){
        if (posicion_.first+1<casilleros_) {
            posicion_.first+=1;
            pasos_aux_++;
            if(turnos_con_pocion_!=0){
                if (pasos_aux_==pasos_con_pocion_) {
                    turnos_++;
                    turnos_con_pocion_--;
                    pasos_aux_=0;
                }
            }else{
                turnos_++;
            }
        }
    }else if(dir==DERECHA){
        if (posicion_.second+1<casilleros_) {
            posicion_.second+=1;
            pasos_aux_++;
            if(turnos_con_pocion_!=0){
                if (pasos_aux_==pasos_con_pocion_) {
                    turnos_++;
                    turnos_con_pocion_--;
                    pasos_aux_=0;
                }
            }else{
                turnos_++;
            }
        }
    }else{
        if (posicion_.second-1>=0) {
            posicion_.second-=1;
            pasos_aux_++;
            if(turnos_con_pocion_!=0){
                if (pasos_aux_==pasos_con_pocion_) {
                    turnos_++;
                    turnos_con_pocion_--;
                    pasos_aux_=0;
                }
            }else{
                turnos_++;
            }
        }
    }
}
void Juego::ingerir_pocion(uint movimientos, uint turnos){
    pasos_con_pocion_+=movimientos;
    turnos_con_pocion_+=turnos;
}