#include <iostream>
#include <list>
using namespace std;

using uint = unsigned int;

// Pre: 0 <= mes < 12
uint dias_en_mes(uint mes) {
    uint dias[] = {
        // ene, feb, mar, abr, may, jun
        31, 28, 31, 30, 31, 30,
        // jul, ago, sep, oct, nov, dic
        31, 31, 30, 31, 30, 31
    };
    return dias[mes - 1];
}

// Ejercicio 7, 8, 9 y 10

// Clase Fecha
class Fecha {
  public:
        Fecha(int mes, int dia);
        int mes();
        int dia();
    #if EJ >= 9 // Para ejercicio 9
    bool operator==(Fecha o);
    #endif
        bool operator<(Fecha h);
        void incrementar_dia();
  private:
        int mes_;
        int dia_;
};

Fecha::Fecha(int mes, int dia):mes_(mes), dia_(dia){}
int Fecha::mes(){
    return this->mes_;
}
int Fecha::dia(){
    return this->dia_;
}

ostream& operator<<(ostream& os, Fecha f){
    os << f.dia() << "/" << f.mes() ;
    return os;
}

bool Fecha::operator<(Fecha h) {
    bool mes_antes = this->mes() < h.mes();
    bool meses_iguales = this->mes() == h.mes();
    bool dia_antes = this->dia() < h.dia();

    return mes_antes || (meses_iguales && dia_antes);
}

#if EJ >= 9
bool Fecha::operator==(Fecha o) {
    bool igual_dia = this->dia() == o.dia();
    bool igual_mes = this->mes() == o.mes();
    return igual_dia && igual_mes;
}
#endif

void Fecha::incrementar_dia(){
    int cant_de_dias_mes = dias_en_mes(mes_);
    if(dia_ == cant_de_dias_mes){
        this->dia_=1;
        if(mes_==12){
            this->mes_=1;
        }else{
            this->mes_++;
        }

    }else{
        this->dia_++;
    }
}



// Ejercicio 11, 12

class Horario{
  public:
    Horario(uint hora, uint min);
    uint hora();
    uint min();
    bool operator==(Horario h);
    bool operator<(Horario h);
  private:
    uint hora_;
    uint min_;

};
Horario::Horario(uint hora, uint min):hora_(hora), min_(min){}
uint Horario::hora(){
    return this->hora_;
}
uint Horario::min(){
    return this->min_;
}

ostream& operator<<(ostream& os, Horario h){
    os << h.hora() <<":"<< h.min() ;
    return os;
}

bool Horario::operator==(Horario h){
    bool igual_hora = this->hora()==h.hora();
    bool igual_min = this->min()==h.min();
    return igual_hora && igual_min;
}
bool Horario::operator<(Horario h){
    bool res;
    if(this->hora()<h.hora()){
        res=true;
    }else if(this->hora()==h.hora()){
        if(this->min()<h.min()){
            res=true;
        }else{
            res=false;
        }
    }else{
        res=false;
    }

    return res;
}
// Ejercicio 13
class Recordatorio{
  public:
    Recordatorio(Fecha f, Horario h, string msj);
    string mensaje();
    Fecha fecha();
    Horario hora();
    bool operator<(Recordatorio r);
  private:
    string mensaje_;
    Fecha fecha_ ;
    Horario horario_;
};
Recordatorio::Recordatorio(Fecha f, Horario h, string msj):mensaje_(msj), fecha_(f), horario_(h){}

string Recordatorio::mensaje(){
    return this->mensaje_;
}
Fecha Recordatorio::fecha(){
    return this->fecha_;
}
Horario Recordatorio::hora(){
    return this->horario_;
}
ostream& operator<<(ostream& os, Recordatorio r){
    os << r.mensaje()<<" @ "<< r.fecha() <<" "<<r.hora();
    return os;
}
//esto es para poder usar el sort en agenda
bool Recordatorio::operator<(Recordatorio r){
    bool fecha_antes = this -> fecha() < r.fecha();
    bool horas_antes = this ->hora()<r.hora();
    bool fechas_iguales = this -> fecha() == r.fecha();
    return fecha_antes || (fechas_iguales && horas_antes);
}
// Ejercicio 14

class Agenda {
  public:
    Agenda(Fecha fecha_inicial);
    void agregar_recordatorio(Recordatorio rec);
    void incrementar_dia();
    list<Recordatorio> recordatorios_de_hoy();
    Fecha hoy();

  private:
    Fecha hoy_;
    list<Recordatorio> recordatorios_;
};

Agenda::Agenda(Fecha fecha_inicial):hoy_(fecha_inicial) {}

void Agenda::agregar_recordatorio(Recordatorio rec){
    recordatorios_.push_back(rec);
}

Fecha Agenda::hoy(){
    return hoy_;
}
// es necesario el this? cuando es necesario?

void Agenda::incrementar_dia(){
    this->hoy_.incrementar_dia();
}

list<Recordatorio> Agenda::recordatorios_de_hoy(){
    list<Recordatorio> reco_de_hoy;
    for(Recordatorio r:this->recordatorios_){
        if(r.fecha()==this->hoy()){
            reco_de_hoy.push_back(r);
        }
    }
    reco_de_hoy.sort();
    return reco_de_hoy;
}


ostream& operator<<(ostream& os, Agenda a){
    list<Recordatorio> recordatorios_de_hoy= a.recordatorios_de_hoy();
    os << a.hoy() <<endl;
    os << "====="<<endl;
    for(Recordatorio r:recordatorios_de_hoy){
        os << r <<endl;
    }
    return os;
}