#include "gtest-1.8.1/gtest.h"
#include "../src/Libreta.h"
#include "../src/Truco.h"
#include <map>
#include <cmath>

using namespace std;

// Ejercicio 4
TEST(Aritmetica, suma) {
    int calculado = 15 +7;
    EXPECT_EQ(calculado, 22);
}

// Ejercicio 5
TEST(Aritmetica, potencia ) {
    float a = pow(10, 2);
    EXPECT_EQ(a, 100);
}

// Ejercicios 6..9
TEST(Aritmetica, Potencia_general){
    for(int i=-5; i<=5; i++){
        float a = pow(i, 2);
        EXPECT_EQ(a, i*i);
    }

}

TEST(Diccionario, obtener){
    map<int, int> dicc ;
    dicc.insert(pair<char,int>(1,3));
    EXPECT_EQ(dicc[1], 3 );

}

TEST(Diccionario, definir){
    map<int, int > dicc;
    EXPECT_FALSE(dicc.count(1));
    dicc.insert(pair<int, int>(1, 5));
    EXPECT_TRUE(dicc.count(1));
}

TEST(Truco, inicio){
    Truco nuevoTruco;
    int puntajeEsperado =0;
    int puntajePrimero = nuevoTruco.puntaje_j1();
    EXPECT_EQ(puntajePrimero ,puntajeEsperado);
    int puntajeSegundo = nuevoTruco.puntaje_j2();
    EXPECT_EQ(puntajeSegundo ,puntajeEsperado);
}

TEST(Truco, buena){
    Truco nuevoTruco;
    int jugador1 = 1;
    int jugador2 = 0;
    bool malas = false;
    bool buenas = true;
    EXPECT_EQ(nuevoTruco.buenas(jugador1), malas);
    for (int i = 0; i < 15; i++) {
        nuevoTruco.sumar_punto(jugador1);
    }
    EXPECT_EQ(nuevoTruco.buenas(jugador1), malas);
    nuevoTruco.sumar_punto(jugador1);
    EXPECT_EQ(nuevoTruco.buenas(jugador1), buenas);
    //suma dos puntos mas
    nuevoTruco.sumar_punto(jugador1);
    nuevoTruco.sumar_punto(jugador1);
    EXPECT_EQ(nuevoTruco.buenas(jugador1), buenas);
}